#include <system.h>
#include "itoa.h"

/*--------------------------------------------------------------------
  Convert a binary number 0..65535 to an ascii string.
  ptr must point to a 6 (or more) character string for result.
--------------------------------------------------------------------*/
void itoa( unsigned int num, char *ptr )
{
  char			ii=0, flag=0;
  unsigned long dig;
  
  if ( num > 9999 )
  {
    // Process ten thousands digit
    dig = num / 10000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 10000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 999 )
  {
    // Process thousands digit
    dig = num / 1000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 1000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 99 )
  {
    // Process hundreds digit
    dig = num / 100;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    flag = 1;
    num -= ( dig * 100 );
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
    
  if ( num > 9 )
  {
    // Process tens digit
    dig = num / 10;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 10 );
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }

  // Process ones digit
  ptr[ii] = (unsigned char) num + 0x30;
  ++ii;
  ptr[ii] = '\0';
}
